package com.chinaitop.depot.intelligent.basicdata.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TJctableExample {
    /**
     * t_jctable
     */
    protected String orderByClause;

    /**
     * t_jctable
     */
    protected boolean distinct;

    /**
     * t_jctable
     */
    protected List<Criteria> oredCriteria;

    public TJctableExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_jctable 2019-03-22
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andVJcNameIsNull() {
            addCriterion("v_jc_name is null");
            return (Criteria) this;
        }

        public Criteria andVJcNameIsNotNull() {
            addCriterion("v_jc_name is not null");
            return (Criteria) this;
        }

        public Criteria andVJcNameEqualTo(String value) {
            addCriterion("v_jc_name =", value, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcNameNotEqualTo(String value) {
            addCriterion("v_jc_name <>", value, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcNameGreaterThan(String value) {
            addCriterion("v_jc_name >", value, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcNameGreaterThanOrEqualTo(String value) {
            addCriterion("v_jc_name >=", value, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcNameLessThan(String value) {
            addCriterion("v_jc_name <", value, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcNameLessThanOrEqualTo(String value) {
            addCriterion("v_jc_name <=", value, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcNameLike(String value) {
            addCriterion("v_jc_name like", value, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcNameNotLike(String value) {
            addCriterion("v_jc_name not like", value, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcNameIn(List<String> values) {
            addCriterion("v_jc_name in", values, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcNameNotIn(List<String> values) {
            addCriterion("v_jc_name not in", values, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcNameBetween(String value1, String value2) {
            addCriterion("v_jc_name between", value1, value2, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcNameNotBetween(String value1, String value2) {
            addCriterion("v_jc_name not between", value1, value2, "vJcName");
            return (Criteria) this;
        }

        public Criteria andVJcCodeIsNull() {
            addCriterion("v_jc_code is null");
            return (Criteria) this;
        }

        public Criteria andVJcCodeIsNotNull() {
            addCriterion("v_jc_code is not null");
            return (Criteria) this;
        }

        public Criteria andVJcCodeEqualTo(String value) {
            addCriterion("v_jc_code =", value, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVJcCodeNotEqualTo(String value) {
            addCriterion("v_jc_code <>", value, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVJcCodeGreaterThan(String value) {
            addCriterion("v_jc_code >", value, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVJcCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_jc_code >=", value, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVJcCodeLessThan(String value) {
            addCriterion("v_jc_code <", value, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVJcCodeLessThanOrEqualTo(String value) {
            addCriterion("v_jc_code <=", value, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVJcCodeLike(String value) {
            addCriterion("v_jc_code like", value, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVJcCodeNotLike(String value) {
            addCriterion("v_jc_code not like", value, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVJcCodeIn(List<String> values) {
            addCriterion("v_jc_code in", values, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVJcCodeNotIn(List<String> values) {
            addCriterion("v_jc_code not in", values, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVJcCodeBetween(String value1, String value2) {
            addCriterion("v_jc_code between", value1, value2, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVJcCodeNotBetween(String value1, String value2) {
            addCriterion("v_jc_code not between", value1, value2, "vJcCode");
            return (Criteria) this;
        }

        public Criteria andVWsSrcIsNull() {
            addCriterion("v_ws_src is null");
            return (Criteria) this;
        }

        public Criteria andVWsSrcIsNotNull() {
            addCriterion("v_ws_src is not null");
            return (Criteria) this;
        }

        public Criteria andVWsSrcEqualTo(String value) {
            addCriterion("v_ws_src =", value, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVWsSrcNotEqualTo(String value) {
            addCriterion("v_ws_src <>", value, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVWsSrcGreaterThan(String value) {
            addCriterion("v_ws_src >", value, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVWsSrcGreaterThanOrEqualTo(String value) {
            addCriterion("v_ws_src >=", value, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVWsSrcLessThan(String value) {
            addCriterion("v_ws_src <", value, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVWsSrcLessThanOrEqualTo(String value) {
            addCriterion("v_ws_src <=", value, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVWsSrcLike(String value) {
            addCriterion("v_ws_src like", value, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVWsSrcNotLike(String value) {
            addCriterion("v_ws_src not like", value, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVWsSrcIn(List<String> values) {
            addCriterion("v_ws_src in", values, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVWsSrcNotIn(List<String> values) {
            addCriterion("v_ws_src not in", values, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVWsSrcBetween(String value1, String value2) {
            addCriterion("v_ws_src between", value1, value2, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVWsSrcNotBetween(String value1, String value2) {
            addCriterion("v_ws_src not between", value1, value2, "vWsSrc");
            return (Criteria) this;
        }

        public Criteria andVVedioIpIsNull() {
            addCriterion("v_vedio_ip is null");
            return (Criteria) this;
        }

        public Criteria andVVedioIpIsNotNull() {
            addCriterion("v_vedio_ip is not null");
            return (Criteria) this;
        }

        public Criteria andVVedioIpEqualTo(String value) {
            addCriterion("v_vedio_ip =", value, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andVVedioIpNotEqualTo(String value) {
            addCriterion("v_vedio_ip <>", value, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andVVedioIpGreaterThan(String value) {
            addCriterion("v_vedio_ip >", value, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andVVedioIpGreaterThanOrEqualTo(String value) {
            addCriterion("v_vedio_ip >=", value, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andVVedioIpLessThan(String value) {
            addCriterion("v_vedio_ip <", value, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andVVedioIpLessThanOrEqualTo(String value) {
            addCriterion("v_vedio_ip <=", value, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andVVedioIpLike(String value) {
            addCriterion("v_vedio_ip like", value, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andVVedioIpNotLike(String value) {
            addCriterion("v_vedio_ip not like", value, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andVVedioIpIn(List<String> values) {
            addCriterion("v_vedio_ip in", values, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andVVedioIpNotIn(List<String> values) {
            addCriterion("v_vedio_ip not in", values, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andVVedioIpBetween(String value1, String value2) {
            addCriterion("v_vedio_ip between", value1, value2, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andVVedioIpNotBetween(String value1, String value2) {
            addCriterion("v_vedio_ip not between", value1, value2, "vVedioIp");
            return (Criteria) this;
        }

        public Criteria andIVedioPortIsNull() {
            addCriterion("i_vedio_port is null");
            return (Criteria) this;
        }

        public Criteria andIVedioPortIsNotNull() {
            addCriterion("i_vedio_port is not null");
            return (Criteria) this;
        }

        public Criteria andIVedioPortEqualTo(Integer value) {
            addCriterion("i_vedio_port =", value, "iVedioPort");
            return (Criteria) this;
        }

        public Criteria andIVedioPortNotEqualTo(Integer value) {
            addCriterion("i_vedio_port <>", value, "iVedioPort");
            return (Criteria) this;
        }

        public Criteria andIVedioPortGreaterThan(Integer value) {
            addCriterion("i_vedio_port >", value, "iVedioPort");
            return (Criteria) this;
        }

        public Criteria andIVedioPortGreaterThanOrEqualTo(Integer value) {
            addCriterion("i_vedio_port >=", value, "iVedioPort");
            return (Criteria) this;
        }

        public Criteria andIVedioPortLessThan(Integer value) {
            addCriterion("i_vedio_port <", value, "iVedioPort");
            return (Criteria) this;
        }

        public Criteria andIVedioPortLessThanOrEqualTo(Integer value) {
            addCriterion("i_vedio_port <=", value, "iVedioPort");
            return (Criteria) this;
        }

        public Criteria andIVedioPortIn(List<Integer> values) {
            addCriterion("i_vedio_port in", values, "iVedioPort");
            return (Criteria) this;
        }

        public Criteria andIVedioPortNotIn(List<Integer> values) {
            addCriterion("i_vedio_port not in", values, "iVedioPort");
            return (Criteria) this;
        }

        public Criteria andIVedioPortBetween(Integer value1, Integer value2) {
            addCriterion("i_vedio_port between", value1, value2, "iVedioPort");
            return (Criteria) this;
        }

        public Criteria andIVedioPortNotBetween(Integer value1, Integer value2) {
            addCriterion("i_vedio_port not between", value1, value2, "iVedioPort");
            return (Criteria) this;
        }

        public Criteria andVVedioUserIsNull() {
            addCriterion("v_vedio_user is null");
            return (Criteria) this;
        }

        public Criteria andVVedioUserIsNotNull() {
            addCriterion("v_vedio_user is not null");
            return (Criteria) this;
        }

        public Criteria andVVedioUserEqualTo(String value) {
            addCriterion("v_vedio_user =", value, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioUserNotEqualTo(String value) {
            addCriterion("v_vedio_user <>", value, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioUserGreaterThan(String value) {
            addCriterion("v_vedio_user >", value, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioUserGreaterThanOrEqualTo(String value) {
            addCriterion("v_vedio_user >=", value, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioUserLessThan(String value) {
            addCriterion("v_vedio_user <", value, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioUserLessThanOrEqualTo(String value) {
            addCriterion("v_vedio_user <=", value, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioUserLike(String value) {
            addCriterion("v_vedio_user like", value, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioUserNotLike(String value) {
            addCriterion("v_vedio_user not like", value, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioUserIn(List<String> values) {
            addCriterion("v_vedio_user in", values, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioUserNotIn(List<String> values) {
            addCriterion("v_vedio_user not in", values, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioUserBetween(String value1, String value2) {
            addCriterion("v_vedio_user between", value1, value2, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioUserNotBetween(String value1, String value2) {
            addCriterion("v_vedio_user not between", value1, value2, "vVedioUser");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdIsNull() {
            addCriterion("v_vedio_pwd is null");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdIsNotNull() {
            addCriterion("v_vedio_pwd is not null");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdEqualTo(String value) {
            addCriterion("v_vedio_pwd =", value, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdNotEqualTo(String value) {
            addCriterion("v_vedio_pwd <>", value, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdGreaterThan(String value) {
            addCriterion("v_vedio_pwd >", value, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdGreaterThanOrEqualTo(String value) {
            addCriterion("v_vedio_pwd >=", value, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdLessThan(String value) {
            addCriterion("v_vedio_pwd <", value, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdLessThanOrEqualTo(String value) {
            addCriterion("v_vedio_pwd <=", value, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdLike(String value) {
            addCriterion("v_vedio_pwd like", value, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdNotLike(String value) {
            addCriterion("v_vedio_pwd not like", value, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdIn(List<String> values) {
            addCriterion("v_vedio_pwd in", values, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdNotIn(List<String> values) {
            addCriterion("v_vedio_pwd not in", values, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdBetween(String value1, String value2) {
            addCriterion("v_vedio_pwd between", value1, value2, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioPwdNotBetween(String value1, String value2) {
            addCriterion("v_vedio_pwd not between", value1, value2, "vVedioPwd");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhIsNull() {
            addCriterion("v_vedio_tdh is null");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhIsNotNull() {
            addCriterion("v_vedio_tdh is not null");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhEqualTo(Integer value) {
            addCriterion("v_vedio_tdh =", value, "vVedioTdh");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhNotEqualTo(Integer value) {
            addCriterion("v_vedio_tdh <>", value, "vVedioTdh");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhGreaterThan(Integer value) {
            addCriterion("v_vedio_tdh >", value, "vVedioTdh");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhGreaterThanOrEqualTo(Integer value) {
            addCriterion("v_vedio_tdh >=", value, "vVedioTdh");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhLessThan(Integer value) {
            addCriterion("v_vedio_tdh <", value, "vVedioTdh");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhLessThanOrEqualTo(Integer value) {
            addCriterion("v_vedio_tdh <=", value, "vVedioTdh");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhIn(List<Integer> values) {
            addCriterion("v_vedio_tdh in", values, "vVedioTdh");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhNotIn(List<Integer> values) {
            addCriterion("v_vedio_tdh not in", values, "vVedioTdh");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhBetween(Integer value1, Integer value2) {
            addCriterion("v_vedio_tdh between", value1, value2, "vVedioTdh");
            return (Criteria) this;
        }

        public Criteria andVVedioTdhNotBetween(Integer value1, Integer value2) {
            addCriterion("v_vedio_tdh not between", value1, value2, "vVedioTdh");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNull() {
            addCriterion("v_cf_code is null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNotNull() {
            addCriterion("v_cf_code is not null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeEqualTo(String value) {
            addCriterion("v_cf_code =", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotEqualTo(String value) {
            addCriterion("v_cf_code <>", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThan(String value) {
            addCriterion("v_cf_code >", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_code >=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThan(String value) {
            addCriterion("v_cf_code <", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThanOrEqualTo(String value) {
            addCriterion("v_cf_code <=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLike(String value) {
            addCriterion("v_cf_code like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotLike(String value) {
            addCriterion("v_cf_code not like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIn(List<String> values) {
            addCriterion("v_cf_code in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotIn(List<String> values) {
            addCriterion("v_cf_code not in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeBetween(String value1, String value2) {
            addCriterion("v_cf_code between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotBetween(String value1, String value2) {
            addCriterion("v_cf_code not between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVJcppIsNull() {
            addCriterion("v_jcpp is null");
            return (Criteria) this;
        }

        public Criteria andVJcppIsNotNull() {
            addCriterion("v_jcpp is not null");
            return (Criteria) this;
        }

        public Criteria andVJcppEqualTo(String value) {
            addCriterion("v_jcpp =", value, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andVJcppNotEqualTo(String value) {
            addCriterion("v_jcpp <>", value, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andVJcppGreaterThan(String value) {
            addCriterion("v_jcpp >", value, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andVJcppGreaterThanOrEqualTo(String value) {
            addCriterion("v_jcpp >=", value, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andVJcppLessThan(String value) {
            addCriterion("v_jcpp <", value, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andVJcppLessThanOrEqualTo(String value) {
            addCriterion("v_jcpp <=", value, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andVJcppLike(String value) {
            addCriterion("v_jcpp like", value, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andVJcppNotLike(String value) {
            addCriterion("v_jcpp not like", value, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andVJcppIn(List<String> values) {
            addCriterion("v_jcpp in", values, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andVJcppNotIn(List<String> values) {
            addCriterion("v_jcpp not in", values, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andVJcppBetween(String value1, String value2) {
            addCriterion("v_jcpp between", value1, value2, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andVJcppNotBetween(String value1, String value2) {
            addCriterion("v_jcpp not between", value1, value2, "vJcpp");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonIsNull() {
            addCriterion("update_person is null");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonIsNotNull() {
            addCriterion("update_person is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonEqualTo(String value) {
            addCriterion("update_person =", value, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonNotEqualTo(String value) {
            addCriterion("update_person <>", value, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonGreaterThan(String value) {
            addCriterion("update_person >", value, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonGreaterThanOrEqualTo(String value) {
            addCriterion("update_person >=", value, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonLessThan(String value) {
            addCriterion("update_person <", value, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonLessThanOrEqualTo(String value) {
            addCriterion("update_person <=", value, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonLike(String value) {
            addCriterion("update_person like", value, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonNotLike(String value) {
            addCriterion("update_person not like", value, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonIn(List<String> values) {
            addCriterion("update_person in", values, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonNotIn(List<String> values) {
            addCriterion("update_person not in", values, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonBetween(String value1, String value2) {
            addCriterion("update_person between", value1, value2, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdatePersonNotBetween(String value1, String value2) {
            addCriterion("update_person not between", value1, value2, "updatePerson");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andVRemarkIsNull() {
            addCriterion("v_remark is null");
            return (Criteria) this;
        }

        public Criteria andVRemarkIsNotNull() {
            addCriterion("v_remark is not null");
            return (Criteria) this;
        }

        public Criteria andVRemarkEqualTo(String value) {
            addCriterion("v_remark =", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotEqualTo(String value) {
            addCriterion("v_remark <>", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkGreaterThan(String value) {
            addCriterion("v_remark >", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("v_remark >=", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkLessThan(String value) {
            addCriterion("v_remark <", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkLessThanOrEqualTo(String value) {
            addCriterion("v_remark <=", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkLike(String value) {
            addCriterion("v_remark like", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotLike(String value) {
            addCriterion("v_remark not like", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkIn(List<String> values) {
            addCriterion("v_remark in", values, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotIn(List<String> values) {
            addCriterion("v_remark not in", values, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkBetween(String value1, String value2) {
            addCriterion("v_remark between", value1, value2, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotBetween(String value1, String value2) {
            addCriterion("v_remark not between", value1, value2, "vRemark");
            return (Criteria) this;
        }

        public Criteria andDelFlagIsNull() {
            addCriterion("del_flag is null");
            return (Criteria) this;
        }

        public Criteria andDelFlagIsNotNull() {
            addCriterion("del_flag is not null");
            return (Criteria) this;
        }

        public Criteria andDelFlagEqualTo(Integer value) {
            addCriterion("del_flag =", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagNotEqualTo(Integer value) {
            addCriterion("del_flag <>", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagGreaterThan(Integer value) {
            addCriterion("del_flag >", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagGreaterThanOrEqualTo(Integer value) {
            addCriterion("del_flag >=", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagLessThan(Integer value) {
            addCriterion("del_flag <", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagLessThanOrEqualTo(Integer value) {
            addCriterion("del_flag <=", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagIn(List<Integer> values) {
            addCriterion("del_flag in", values, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagNotIn(List<Integer> values) {
            addCriterion("del_flag not in", values, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagBetween(Integer value1, Integer value2) {
            addCriterion("del_flag between", value1, value2, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagNotBetween(Integer value1, Integer value2) {
            addCriterion("del_flag not between", value1, value2, "delFlag");
            return (Criteria) this;
        }
    }

    /**
     * t_jctable
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_jctable 2019-03-22
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}